"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CodepenPrefill =
/*#__PURE__*/
function (_Component) {
  _inherits(CodepenPrefill, _Component);

  function CodepenPrefill(props) {
    var _this;

    _classCallCheck(this, CodepenPrefill);

    _this = _possibleConstructorReturn(this, (CodepenPrefill.__proto__ || Object.getPrototypeOf(CodepenPrefill)).call(this, props));
    var defaults = {
      // https://blog.codepen.io/documentation/api/prefill/
      title: '',
      // The title of the pen.
      description: '',
      // The description of the pen.
      tags: [],
      // an array of strings
      editors: '111',
      // Which editors are open. 1 is open. order is: HTML, CSS, JS.
      layout: 'left',
      // Optional layouts: top || left || right
      html: '',
      // The HTML code to fill in the HTML pane.
      html_pre_processor: 'none',
      // Optional values: "none" || "slim" || "haml" || "markdown"
      css: '',
      // The CSS code to fill in the CSS pane.
      css_pre_processor: 'none',
      // Optional values: "none" || "less" || "scss" || "sass" || "stylus"
      css_starter: 'neither',
      // Optional values:  "normalize" || "reset" || "neither",
      css_prefix: 'neither',
      // Optional values:  "autoprefixer" || "prefixfree" || "neither"
      js: '',
      // The JavaScript code to fill in the JS pane.
      js_pre_processor: 'none',
      // Optional values: "none" || "coffeescript" || "babel" || "livescript" || "typescript"
      html_classes: '',
      // CSS class to apply to html tag.
      head: '',
      // Content to include inside the HTML head tag.
      css_external: '',
      // Use semi-colon to separate multiple files.
      js_external: '',
      // Use semi-colon to separate multiple files.
      // Optional values: true || false - 
      // When the Pen is saved, it will save as Private if logged in user has that privilege, 
      // otherwise it will save as public
      private: false,
      // If supplied, the Pen will save as a fork of this id.
      // Note it's not the slug, but ID.
      // You can find the ID of a Pen with `window.CP.pen.id` in the browser console.
      parent: null
    };
    _this.curPayload = _this.toSend(defaults);
    return _this;
  } // convert the component props to the payload fields as per codepen documentation


  _createClass(CodepenPrefill, [{
    key: "toSend",
    value: function toSend(cur) {
      var _this2 = this;

      var internalProps = ['label', 'target', 'className'];
      var convertedProps = {}; // do not send internal props
      // convert camelCase props to underscored keys

      Object.keys(this.props).forEach(function (key) {
        if (internalProps.indexOf(key) === -1) {
          var underscored = key.replace(/([A-Z])/g, function ($1) {
            return "_".concat($1.toLowerCase());
          });
          convertedProps[underscored] = _this2.props[key];
        }
      });
      return Object.assign(cur, convertedProps);
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("span", {
        style: {
          display: 'inline-block'
        }
      }, _react.default.createElement("form", {
        style: {
          display: 'inline-block'
        },
        className: this.props.formClass,
        action: "https://codepen.io/pen/define",
        method: "POST",
        target: this.props.target,
        rel: "noopener noreferrer"
      }, _react.default.createElement("input", {
        type: "hidden",
        name: "data",
        value: JSON.stringify(this.toSend(this.curPayload))
      }), _react.default.createElement("button", {
        type: "submit",
        className: this.props.className
      }, this.props.label)));
    }
  }]);

  return CodepenPrefill;
}(_react.Component);

CodepenPrefill.defaultProps = {
  label: 'Prefill CodePen',
  target: '',
  className: ''
};
CodepenPrefill.propTypes = {
  title: _propTypes.default.string,
  description: _propTypes.default.string,
  tags: _propTypes.default.array,
  editors: _propTypes.default.string,
  layout: _propTypes.default.string,
  html: _propTypes.default.string,
  html_pre_processor: _propTypes.default.string,
  css: _propTypes.default.string,
  css_pre_processor: _propTypes.default.string,
  css_starter: _propTypes.default.string,
  css_prefix: _propTypes.default.string,
  js: _propTypes.default.string,
  js_pre_processor: _propTypes.default.string,
  html_classes: _propTypes.default.string,
  head: _propTypes.default.string,
  css_external: _propTypes.default.string,
  js_external: _propTypes.default.string,
  private: _propTypes.default.bool,
  parent: _propTypes.default.number
};
var _default = CodepenPrefill;
exports.default = _default;